//*******************************************************************************
//* Dieses Programm wurde von Ulrich Radig fr Atmel AVR C geschrieben  		*
//* 																			*
//* Ich wnsche jeden viel Spa mit diesen kleinen Web-Server der ohne 			*
//* zustzlichen Speicher auskommt.												*
//*																				*
//* Bei Fragen und Verbesserungen wendet euch per EMail an						*
//*																				*
//* mail@ulrichradig.de															*
//*																				*
//* oder im Forum meiner Web Page : www.ulrichradig.de							*
//*																				*
//*******************************************************************************

#include <ftpd.h>

int ftpd (char* buffer,int *bufferlen)
{	
	if (TCP_OPEN(buffer,bufferlen)==1)
		{
		printf("Connection to FTP Server Open\n");
		return(0);
		}
	
	//Einlesen des TCP Socket
	unsigned int	TCP_Socket = (buffer[TCP_SRCPORT]<<8) + buffer[TCP_SRCPORT+1];
	
		for (int a=0;a<10;a++)
		{
		//Antwort FTP Server Vorhanden 
		if ((buffer[TCP_HDRFLAGS+1]&ACK_FLAG) > 0 && TCP_Socket == TCP_Socket_Store[a] && TCP_Socket_Status[a] == 0)
			{
			//Speichert Sequenzcounter und Aknowledgecounter
			tcp_store(buffer);		
			//Setzen des Ack Flag
			buffer[TCP_HDRFLAGS+1] |= ACK_FLAG;
			//FTP Server Antwort Packet
			tcp_add_data (FTP_CONNECT,buffer,bufferlen);	
			//Erzeugt ein TCP Packet 
			tcp_make(buffer);			
			//Sendet das erzeugte TCP Packet 
			Write_Ethernet_Frame (buffer,*bufferlen);
			TCP_Socket_Status[a] = 4; //FTP Socket Open
			return(0);
			}
		}
		
		for (int a=0;a<10;a++)
		{
		
		if ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0 && TCP_Socket == TCP_Socket_Store[a] && TCP_Socket_Status[a] == 4)
			{
				//Errechnet startpunkt der Daten im Tcp buffer
				//IP Headerlnge + TCP Headerlnge + Ethernetframe
				unsigned int result16 = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;
				
				printf("Recieve: ");
				
				for (int b = result16;b <= (*bufferlen);b++)
					{
					if (buffer[b] == 0) {break;}
					printf("%c",buffer[b]);
					}
				printf("\n");
				
				//Speichert Sequenzcounter und Aknowledgecounter
				tcp_store(buffer);	
				
				//Setzen des Ack Flag
				buffer[TCP_HDRFLAGS+1] |= ACK_FLAG;
				
				//FTP Server Antwort Packet
				
				int command = memcmp(&buffer[result16],"USER",4); //Commando USER
				if ( command == 0) 
					{
					tcp_add_data (FTP_USER_OK,buffer,bufferlen);
					goto CMD_FOUND;
					}

				command = memcmp(&buffer[result16],"XPWD",4); //Commando PWD
				if ( command == 0) 
					{
					tcp_add_data (FTP_PWD,buffer,bufferlen);
					goto CMD_FOUND;
					}
				
				command = memcmp(&buffer[result16],"PWD",3); //Commando PWD
				if ( command == 0) 
					{
					tcp_add_data (FTP_PWD,buffer,bufferlen);
					goto CMD_FOUND;
					}
				
				command = memcmp(&buffer[result16],"NOOP",4); //Commando NOOP
				if ( command == 0) 
					{
					tcp_add_data (FTP_CMD_OK,buffer,bufferlen);
					goto CMD_FOUND;
					}
					
				command = memcmp(&buffer[result16],"QUIT",4); //Commando NOOP
				if ( command == 0) 
					{
					tcp_add_data (FTP_CMD_OK,buffer,bufferlen);
					TCP_Socket_Status[a] = 5; //Ready to FTP Socket Close
					goto CMD_FOUND;
					}

				tcp_add_data (FTP_CMD_N_IM,buffer,bufferlen);
				//Erzeugt ein TCP Packet 
CMD_FOUND:		tcp_make(buffer);	
		
				//Sendet das erzeugte TCP Packet 
				Write_Ethernet_Frame (buffer,*bufferlen);
				TCP_Socket_Status[a] = 4; //FTP Socket Open
			return (0);		
			}
		}

	for (int a=0;a<10;a++)
		{
		if (TCP_Socket == TCP_Socket_Store[a] && TCP_Socket_Status[a] == 5)
			{
			TCP_Socket_Store[a] = 0;
			TCP_Socket_Status[a] = 0;
			printf("\nTCP Socket Close %d\n",TCP_Socket);
			TCP_PORT_CLOSE (buffer,bufferlen);
			break;
			}
		}
return (0);
}
